#ifndef _GAME_H_
#define _GAME_H_

#include "playfield.h"
#include "creatures.h"

#define MAX_DT 0.1
#define DT_EPSILON 0.0001

#define CAMERA_REVOLVE_DIST 2
#define CAMERA_TRACK_DIST 1
#define CAMERA_SLIDE_DIST 2
#define CAMERA_FOLLOW_DIST 1
#define CAMERA_SCALE 300
#define CAMERA_CUTOFF 1000

#define COLLIDE_EXT 0 //0.1
#define COLLIDE_MULT 4

class game
{
	public:
	game();
	~game();

	virtual void setup();
	virtual void play();
	virtual void live();
	virtual void draw();

	void dohighscore();

	void synctime();
	void calctime();

	void fadedown();
	int project(vector r,const vector &norm,int &x_s,int &y_s,bool onesided=false);

	playfield *p;

	double dt,prevtime,t;

//	vector up,toward,left;
//	vector x_axis,y_axis,z_axis;
//	vector moveoffs,slideoffs;
	matrix cam,cam_current,cam_inv;

	bool playing,firstframe;
	int gamenum;

	int score;
};

class wormgame:public game
{
	public:
	wormgame();

	void live();

	playerworm w;
};

#define SIMPLE_APPLEFACTOR 0.008

class simplegame:public wormgame
{
	public:
	simplegame();

	void setup();

	void live();
	void draw();

	apple a;
};

#define HUNT_APPLEFACTOR 0.004

class huntgame:public wormgame
{
	public:
	huntgame();

	void setup();

	void live();
	void draw();

	skittler a;
};

class blindgame:public simplegame
{
	public:
	blindgame();

	void draw();
};


extern game *g;

extern int detailmult[];

#endif
