#include <allegro.h>
#include <string.h>

#include <goa/bitmap.h>
#include <goa/png.h>

static BITMAP *_load_any_bitmap(char *filename)
{
	char *buf=0,*ext;
	RGB pal[256];
	BITMAP *pic;

	buf=new char[strlen(filename)+5];
	strcpy(buf,filename);
	ext=buf+strlen(filename);

	fix_filename_slashes(buf);

	strcpy(ext,".png"); pic=load_png(buf,pal);
	if(!pic) { strcpy(ext,".tga"); pic=load_tga(buf,pal); }
	if(!pic) { strcpy(ext,".pcx"); pic=load_pcx(buf,pal); }
	if(!pic) { strcpy(ext,".lbm"); pic=load_lbm(buf,pal); }
	if(!pic) { strcpy(ext,".bmp"); pic=load_bmp(buf,pal); }

	delete buf;

	return(pic);
}

static unsigned char convtable[65536];
static bool convok=false;

BITMAP *load_any_bitmap(char *filename)
{
	if(bitmap_color_depth(screen)==8)
	{
		BITMAP *pic,*res;
		set_color_depth(15);
		pic=_load_any_bitmap(filename);
		set_color_depth(8);

		res=clone_bitmap(pic);
		destroy_bitmap(pic);

		return(res);
	}
	return(_load_any_bitmap(filename));
}

BITMAP *load_any_bitmap_dither(char *filename)
{
	BITMAP *res;

	set_color_conversion(COLORCONV_TOTAL|COLORCONV_DITHER);

	if(bitmap_color_depth(screen)==8)
	{
		BITMAP *pic;
		set_color_depth(15);
		pic=_load_any_bitmap(filename);
		set_color_depth(8);

		res=clone_bitmap(pic);
		destroy_bitmap(pic);
	}
	else res=_load_any_bitmap(filename);

	set_color_conversion(COLORCONV_TOTAL);

	return(res);
}

BITMAP *clone_bitmap(BITMAP *bm)
{
	BITMAP *res=create_bitmap(bm->w,bm->h);
	if(res) blit(bm,res,0,0,0,0,bm->w,bm->h);
	return(res);
}
