#include <allegro.h>

#include <goa/blend.h>
#include <goa/types.h>


// first argument is written pixel, second is background




static uint32 trans15(uint32 c1,uint32 c2,uint32 a)
{ return(((c1&0x7bde)>>1)+((c2&0x7bde)>>1)+(c1&c2&0x421)); } // ?

static uint32 trans16(uint32 c1,uint32 c2,uint32 a)
{ return(((c1&0xf7de)>>1)+((c2&0xf7de)>>1)+(c1&c2&0x821)); }

static uint32 trans24(uint32 c1,uint32 c2,uint32 a)
{ return(((c1&0xfefefe)>>1)+((c2&0xfefefe)>>1)+(c1&c2&0x010101)); }

static uint32 trans2515(uint32 c1,uint32 c2,uint32 a)
{
	int c=((c1&0x7bde)>>1)+((c2&0x7bde)>>1)+(c1&c2&0x421);
	return(((c&0x7bde)>>1)+((c2&0x7bde)>>1)+(c&c2&0x421));
} // ?

static uint32 trans2516(uint32 c1,uint32 c2,uint32 a)
{
	int c=((c1&0xf7de)>>1)+((c2&0xf7de)>>1)+(c1&c2&0x821);
	return(((c&0xf7de)>>1)+((c2&0xf7de)>>1)+(c&c2&0x821));
}

static uint32 trans2524(uint32 c1,uint32 c2,uint32 a)
{
	int c=((c1&0xfefefe)>>1)+((c2&0xfefefe)>>1)+(c1&c2&0x010101);
	return(((c&0xfefefe)>>1)+((c2&0xfefefe)>>1)+(c&c2&0x010101));
}

static uint32 trans7515(uint32 c1,uint32 c2,uint32 a)
{
	int c=((c1&0x7bde)>>1)+((c2&0x7bde)>>1)+(c1&c2&0x421);
	return(((c&0x7bde)>>1)+((c1&0x7bde)>>1)+(c&c1&0x421));
} // ?

static uint32 trans7516(uint32 c1,uint32 c2,uint32 a)
{
	int c=((c1&0xf7de)>>1)+((c2&0xf7de)>>1)+(c1&c2&0x821);
	return(((c&0xf7de)>>1)+((c1&0xf7de)>>1)+(c&c1&0x821));
}

static uint32 trans7524(uint32 c1,uint32 c2,uint32 a)
{
	int c=((c1&0xfefefe)>>1)+((c2&0xfefefe)>>1)+(c1&c2&0x010101);
	return(((c&0xfefefe)>>1)+((c1&0xfefefe)>>1)+(c&c1&0x010101));
}

static uint32 additive15(uint32 c1,uint32 c2,uint32 a)
{ return(((((((c1^c2)>>1)^((c1>>1)+(c2>>1)))&0x4210)>>4)*0x1F)|(c1+c2)); }

static uint32 additive16(uint32 c1,uint32 c2,uint32 a)
{ return(((((((c1^c2)>>1)^((c1>>1)+(c2>>1)))&0x8410)>>4)*0x1F)|(c1+c2)); }

static uint32 additive24(uint32 c1,uint32 c2,uint32 a)
{ return(((((((c1^c2)>>1)^((c1>>1)+(c2>>1)))&0x808080)>>4)*0xFF)|(c1+c2)); }

static uint32 dodge15(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res,a,b;
	a=0x7c00-(c1&0x7c00); b=c2&0x7c00; // red
	res=(b>=a)?0x7c00:((b<<5)/a<<10);
	a=0x3e0-(c1&0x3e0); b=c2&0x3e0; // green
	res|=(b>=a)?0x3e0:((b<<5)/a<<5);
	a=0x1f-(c1&0x1f); b=c2&0x1f; // blue
	res|=(b>=a)?0x1f:(b<<5)/a;

	return(res);
}

static uint32 dodge16(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res,a,b;
	a=0xf800-(c1&0xf800); b=c2&0xf800; // red
	res=(b>=a)?0xf800:((b<<5)/a<<11);
	a=0x7e0-(c1&0x7e0); b=c2&0x7e0; // green
	res|=(b>=a)?0x7e0:((b<<6)/a<<5);
	a=0x1f-(c1&0x1f); b=c2&0x1f; // blue
	res|=(b>=a)?0x1f:(b<<5)/a;

	return(res);
}

static uint32 dodge24(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res,a,b;
	a=0xff0000-(c1&0xff0000); b=c2&0xff0000; // red
	res=(b>=a)?0xff0000:((b<<8)/a<<16);
	a=0xff00-(c1&0xff00); b=c2&0xff00; // green
	res|=(b>=a)?0xff00:((b<<8)/a<<8);
	a=0xff-(c1&0xff); b=c2&0xff; // blue
	res|=(b>=a)?0xff:(b<<8)/a;

	return(res);
}

static uint32 screen15(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res=0x7fff,a,b;
	a=c1&0x7c00; b=c2&0x7c00; // red
	res-=(((a*b+0x8000*0x8000-0x400)>>15)-a-b)&0x7c00;
	a=c1&0x3e0; b=c2&0x3e0; // green
	res-=(((a*b+0x400*0x400-0x20)>>10)-a-b)&0x3e0;
	a=c1&0x1f; b=c2&0x1f; // blue
	res-=((a*b+0x20*0x20-1)>>5)-a-b;

	return(res);
}

static uint32 screen16(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res=0xffff,a,b;
	a=c1&0xf800; b=c2&0xf800; // red
	res-=(((a*b-0x800)>>16)-a-b)&0xf800;
	a=c1&0x7e0; b=c2&0x7e0; // green
	res-=(((a*b+0x800*0x800-0x20)>>11)-a-b)&0x7e0;
	a=c1&0x1f; b=c2&0x1f; // blue
	res-=((a*b+0x20*0x20-1)>>5)-a-b; // mask?

	return(res);
}

static uint32 screen24(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res=0xffffff,a,b;
	a=c1&0xff0000; b=c2&0xff0000; // red
	res-=((((a>>8)*(b>>8)-1)>>8)-a-b)&0xff0000;
	a=c1&0xff00; b=c2&0xff00; // green
	res-=(((a*b-0x100)>>16)-a-b)&0xff00;
	a=c1&0xff; b=c2&0xff; // blue
	res-=((a*b+0x100*0x100-1)>>8)-a-b;

	return(res);
}

static uint32 millennium15(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res,a,b,tmp;
	a=c1&0x7c00; b=c2&0x7c00; // red
	res=b>a?b:((tmp=2*a-b)>0x7c00?0x7c00:tmp);
	a=c1&0x3e0; b=c2&0x3e0; // green
	res|=b>a?b:((tmp=2*a-b)>0x3e0?0x3e0:tmp);
	a=c1&0x1f; b=c2&0x1f; // blue
	res|=b>a?b:((tmp=2*a-b)>0x1f?0x1f:tmp);

	return(res);
}

static uint32 millennium16(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res,a,b,tmp;
	a=c1&0xf800; b=c2&0xf800; // red
	res=b>a?b:((tmp=2*a-b)>0xf800?0xf800:tmp);
	a=c1&0x7e0; b=c2&0x7e0; // green
	res|=b>a?b:((tmp=2*a-b)>0x7e0?0x7e0:tmp);
	a=c1&0x1f; b=c2&0x1f; // blue
	res|=b>a?b:((tmp=2*a-b)>0x1f?0x1f:tmp);

	return(res);
}

static uint32 millennium24(uint32 c1,uint32 c2,uint32 alpha)
{
	uint32 res,a,b,tmp;
	a=c1&0xff0000; b=c2&0xff0000; // red
	res=b>a?b:((tmp=2*a-b)>0xff0000?0xff0000:tmp);
	a=c1&0xff00; b=c2&0xff00; // green
	res|=b>a?b:((tmp=2*a-b)>0xff00?0xff00:tmp);
	a=c1&0xff; b=c2&0xff; // blue
	res|=b>a?b:((tmp=2*a-b)>0xff?0xff:tmp);

	return(res);
}

void set_fast_trans_blender(int r,int g,int b)
{
	set_blender_mode(trans15,trans16,trans24,r,g,b,0);
}

void set_fast_trans_blender_25(int r,int g,int b)
{
	set_blender_mode(trans2515,trans2516,trans2524,r,g,b,0);
}

void set_fast_trans_blender_75(int r,int g,int b)
{
	set_blender_mode(trans7515,trans7516,trans7524,r,g,b,0);
}


void set_fast_add_blender(int r,int g,int b)
{
	set_blender_mode(additive15,additive16,additive24,r,g,b,0);
}

void set_fast_dodge_blender(int r,int g,int b)
{
	set_blender_mode(dodge15,dodge16,dodge24,r,g,b,0);
}

void set_fast_screen_blender(int r,int g,int b)
{
	set_blender_mode(screen15,screen16,screen24,r,g,b,0);
}

void set_fast_millennium_blender(int r,int g,int b)
{
	set_blender_mode(millennium15,millennium16,millennium24,r,g,b,0);
}
