#include <allegro.h>

#include <goa/input.h>



static char oldkey[KEY_MAX]={0};

int keydown()
{
	for(int i=0;i<KEY_MAX;i++) if(key[i]) return(i);
	return(0);
}

int keywait()
{
	int k;
	do { k=keydown(); } while(!k);
	return(k);
}

int keystroke()
{
	int k=0;
	for(int i=0;i<KEY_MAX;i++)
	{
		if(!key[i]!=!oldkey[i]) // heh.
		{
			k=key[i]?i:-i;
			oldkey[i]=key[i];
		}
	}
	return(k);
}

void keyreset()
{
	for(int i=0;i<KEY_MAX;i++) oldkey[i]=key[i];
}

int readallkeys()
{
	int k;

	while(!(k=checkallkeys()));

	return(k);
}

int checkallkeys()
{
	if(keypressed()) return(readkey());
	int k=keystroke();
	if(k>=KEY_MODIFIERS) return(k<<8);
	return(0);
}



char *key_description[KEY_MAX]={0};

void init_descriptions()
{
	if(key_description[0]) return;

	for(int i=0;i<KEY_MAX;i++) key_description[i]="";

	key_description[KEY_A]="A";
	key_description[KEY_B]="B";
	key_description[KEY_C]="C";
	key_description[KEY_D]="D";
	key_description[KEY_E]="E";
	key_description[KEY_F]="F";
	key_description[KEY_G]="G";
	key_description[KEY_H]="H";
	key_description[KEY_I]="I";
	key_description[KEY_J]="J";
	key_description[KEY_K]="K";
	key_description[KEY_L]="L";
	key_description[KEY_M]="M";
	key_description[KEY_N]="N";
	key_description[KEY_O]="O";
	key_description[KEY_P]="P";
	key_description[KEY_Q]="Q";
	key_description[KEY_R]="R";
	key_description[KEY_S]="S";
	key_description[KEY_T]="T";
	key_description[KEY_U]="U";
	key_description[KEY_V]="V";
	key_description[KEY_W]="W";
	key_description[KEY_X]="X";
	key_description[KEY_Y]="Y";
	key_description[KEY_Z]="Z";
	key_description[KEY_0]="0";
	key_description[KEY_1]="1";
	key_description[KEY_2]="2";
	key_description[KEY_3]="3";
	key_description[KEY_4]="4";
	key_description[KEY_5]="5";
	key_description[KEY_6]="6";
	key_description[KEY_7]="7";
	key_description[KEY_8]="8";
	key_description[KEY_9]="9";
	key_description[KEY_0_PAD]="Numpad 0";
	key_description[KEY_1_PAD]="Numpad 1";
	key_description[KEY_2_PAD]="Numpad 2";
	key_description[KEY_3_PAD]="Numpad 3";
	key_description[KEY_4_PAD]="Numpad 4";
	key_description[KEY_5_PAD]="Numpad 5";
	key_description[KEY_6_PAD]="Numpad 6";
	key_description[KEY_7_PAD]="Numpad 7";
	key_description[KEY_8_PAD]="Numpad 8";
	key_description[KEY_9_PAD]="Numpad 9";
	key_description[KEY_F1]="F1";
	key_description[KEY_F2]="F1";
	key_description[KEY_F3]="F2";
	key_description[KEY_F4]="F3";
	key_description[KEY_F5]="F4";
	key_description[KEY_F6]="F5";
	key_description[KEY_F7]="F6";
	key_description[KEY_F8]="F7";
	key_description[KEY_F9]="F8";
	key_description[KEY_F10]="F10";
	key_description[KEY_F11]="F11";
	key_description[KEY_F12]="F12";
	key_description[KEY_ESC]="Esc";
	key_description[KEY_TILDE]="~";
	key_description[KEY_MINUS]="-";
	key_description[KEY_EQUALS]="=";
	key_description[KEY_BACKSPACE]="Backspace";
	key_description[KEY_TAB]="Tab";
	key_description[KEY_OPENBRACE]="[";
	key_description[KEY_CLOSEBRACE]="]";
	key_description[KEY_ENTER]="Enter";
	key_description[KEY_COLON]=":";
	key_description[KEY_QUOTE]="'";
	key_description[KEY_BACKSLASH]="\\";
	key_description[KEY_BACKSLASH2]="\\ (2)";
	key_description[KEY_COMMA]=",";
	key_description[KEY_STOP]=".";
	key_description[KEY_SLASH]="/";
	key_description[KEY_SPACE]="Space";
	key_description[KEY_INSERT]="Insert";
	key_description[KEY_DEL]="Delete";
	key_description[KEY_HOME]="Home";
	key_description[KEY_END]="End";
	key_description[KEY_PGUP]="Page Up";
	key_description[KEY_PGDN]="Page Down";
	key_description[KEY_LEFT]="Left";
	key_description[KEY_RIGHT]="Right";
	key_description[KEY_UP]="Up";
	key_description[KEY_DOWN]="Down";
	key_description[KEY_SLASH_PAD]="Numpad /";
	key_description[KEY_ASTERISK]="*";
	key_description[KEY_MINUS_PAD]="Numpad -";
	key_description[KEY_PLUS_PAD]="Numpad +";
	key_description[KEY_DEL_PAD]="Numpad Delete";
	key_description[KEY_ENTER_PAD]="Numpad Enter";
	key_description[KEY_PRTSCR]="Print Screen";
	key_description[KEY_PAUSE]="Pause";

//	key_description[KEY_ABNT_C1]="ABNT C1";
//	key_description[KEY_YEN]="Yen";
//	key_description[KEY_KANA]="Kana";
//	key_description[KEY_CONVERT]="Convert";
//	key_description[KEY_NOCONVERT]="No Convert";
//	key_description[KEY_AT]="At";
//	key_description[KEY_CIRCUMFLEX]="Circumflex";
//	key_description[KEY_COLON2]="Colon (2)";
//	key_description[KEY_KANJI]="Kanji";

	key_description[KEY_LSHIFT]="Left Shift";
	key_description[KEY_RSHIFT]="Right Shift";
	key_description[KEY_LCONTROL]="Left Ctrl";
	key_description[KEY_RCONTROL]="Right Ctrl";
	key_description[KEY_ALT]="Alt";
	key_description[KEY_ALTGR]="Alt Gr";
	key_description[KEY_LWIN]="Left Windows";
	key_description[KEY_RWIN]="Right Windows";
	key_description[KEY_MENU]="Menu";
	key_description[KEY_SCRLOCK]="Scroll Lock";
	key_description[KEY_NUMLOCK]="Num Lock";
	key_description[KEY_CAPSLOCK]="Caps Lock";
}





































