#include <allegro.h>
#include <allegro/internal/aintern.h>

#include <goa/line.h>
#include <goa/types.h>

#include "line_inline.h"



/*void fast_line(BITMAP *bm,int x1,int y1,int x2,int y2,int col)
{
	int x_start,y_start,x_end,y_end,dx,dy,clip=bm->clip;
	bm->clip=false;

	if(y1<y2)
	{
		x_start=x1; y_start=y1;
		x_end=x2; y_end=y2;
	}
	else
	{
		x_start=x2; y_start=y2;
		x_end=x1; y_end=y1;
	}

	dx=x_end-x_start; dy=y_end-y_start;

	if(clip)
	if(!clip_line(x_start,y_start,x_end,y_end,bm->cl,bm->ct,bm->cr-1,bm->cb-1))
	goto hell;

/ *	if(clip)
	{
		if(y_end<0||y_start>=bm->h) goto hell; // rough y clip
		if(dx>0) { if(x_end<0||x_start>=bm->w) goto hell; } // rough x clip 1
		else { if(x_end>=bm->w||x_start<0) goto hell; } // rough x clip 2
	}* /

	if(ABS(dx)>dy) // shallow
	{
		double slope,x;
		int x_offs;

		_init_shallow(x_start,y_start,x_end,y_end,slope,x,x_offs,dx,dy);

		//if(clip)
		//if(!_clip_shallow(x_start,y_start,x_end,y_end,slope,x,x_offs,dx,dy,bm->w,bm->h))
		//goto hell;

		int x_prev=x_start;
		for(int y=y_start;y!=y_end;y++)
		{
			hline(bm,x_prev,y,int(x),col);
			x_prev=int(x)+x_offs;
			x+=slope;
		}
		hline(bm,x_prev,y_end,x_end,col);
	}
	else // steep
	{
		double slope,y;
		int x_offs;

		_init_steep(x_start,y_start,x_end,y_end,slope,y,x_offs,dx,dy);

//		if(clip)
//		if(!_clip_steep(x_start,y_start,x_end,y_end,slope,y,x_offs,dx,dy,bm->w,bm->h))
//		goto hell;

		int y_prev=y_start;
		for(int x=x_start;x!=x_end;x+=x_offs)
		{
			vline(bm,x,y_prev,int(y),col);
			y_prev=int(y)+1;
			y+=slope;
		}
		vline(bm,x_end,y_prev,y_end,col);
	}
	hell:
	bm->clip=clip;
}*/


void fast_line(BITMAP *bm,int x1,int y1,int x2,int y2,int col)
{
	int x_start,y_start,x_end,y_end,dx,dy,clip=bm->clip;
	int stepsize,x_step,error,adj_up,adj_down,initial_len,final_len,len;

	if(clip)
	if(!clip_line(x1,y1,x2,y2,bm->cl,bm->ct,bm->cr-1,bm->cb-1)) return;

	bm->clip=false;

	if(y1<y2)
	{
		x_start=x1; y_start=y1;
		x_end=x2; y_end=y2;
	}
	else
	{
		x_start=x2; y_start=y2;
		x_end=x1; y_end=y1;
	}

	dx=x_end-x_start;

	if(dx<0) { x_step=-1; dx=-dx; }
	else x_step=1;

	dy=y_end-y_start;

	if(dx==0)
	{
		vline(bm,x_start,y_start,y_end,col);
	}
	else if(dy==0)
	{
		hline(bm,x_start,y_start,x_end,col);
	}
	else if(dx==dy)
	{
		for(int i=0;i<=dx;i++)
		{
			putpixel(bm,x_start+i*x_step,y_start+i,col);
		}
	}
	else if(dx>dy)
	{
		stepsize=(dx/dy)*x_step;
		adj_up=(dx%dy)*2;
		adj_down=dy*2;
		error=adj_up/2-adj_down;
		initial_len=final_len=stepsize/2+x_step;

		if(stepsize&1)
		{
			/* If there're an odd number of pixels per run, we have 1 pixel that can't
			be allocated to either the initial or last partial run, so we'll add 0.5
			to error term so this pixel will be handled by the normal full-run loop */
			error+=dy;
		}
		else
		{
			/* If the basic run length is even and there's no fractional
			advance, we have one pixel that could go to either the initial
			or last partial run, which we'll arbitrarily allocate to the
			last run */
			if(adj_up==0) initial_len-=x_step;
		}

		int x=x_start;

		hline(bm,x,y_start,x+initial_len-x_step,col);
		x+=initial_len;

		for(int y=y_start+1;y<y_end;y++)
		{
			len=stepsize;
			error+=adj_up;
			if(error>0)
			{
				len+=x_step;
				error-=adj_down;
			}
			hline(bm,x,y,x+len-x_step,col);
			x+=len;
		}
		hline(bm,x,y_end,x+final_len-x_step,col);
	}
	else
	{
		stepsize=(dy/dx);
		adj_up=(dy%dx)*2;
		adj_down=dx*2;
		error=adj_up/2-adj_down;
		initial_len=final_len=stepsize/2+1;

		if(stepsize&1)
		{
			/* If there're an odd number of pixels per run, we have 1 pixel that can't
			be allocated to either the initial or last partial run, so we'll add 0.5
			to error term so this pixel will be handled by the normal full-run loop */
			error+=dx;
		}
		else
		{
			/* If the basic run length is even and there's no fractional
			advance, we have one pixel that could go to either the initial
			or last partial run, which we'll arbitrarily allocate to the
			last run */
			if(adj_up==0) initial_len-=1;
		}

		int y=y_start;

		vline(bm,x_start,y,y+initial_len-1,col);
		y+=initial_len;

		for(int x=x_start+x_step;x!=x_end;x+=x_step)
		{
			len=stepsize;
			error+=adj_up;
			if(error>0)
			{
				len+=1;
				error-=adj_down;
			}
			vline(bm,x,y,y+len-1,col);
			y+=len;
		}
		vline(bm,x_end,y,y+final_len-1,col);
	}

	bm->clip=clip;
}

void antialias_line(BITMAP *bm,int x1,int y1,int x2,int y2,int col)
{
	int clip=bm->clip;
	int oldalpha=_blender_alpha;

	if(clip&&x1>=bm->cl&&x1<bm->cr&&y1>=bm->ct&&y1<bm->cb&&
	x2>=bm->cl&&x2<bm->cr&&y2>=bm->ct&&y2<bm->cb) bm->clip=false;

	if(bitmap_color_depth(bm)==8)
	{
		line(bm,x1,y1,x2,y2,col);
		goto hell;
	}

	uint16 err,err_delta,err_tmp;
	uint32 dx,dy;
	int x_dir;

	if(y1>y2)
	{
		int tmp;
		tmp=y1; y1=y2; y2=tmp;
		tmp=x1; x1=x2; x2=tmp;
	}

	if(x2>x1) { x_dir=1; dx=x2-x1; }
	else { x_dir=-1; dx=x1-x2; }

	if(!(dy=y2-y1))
	{
		hline(bm,x1,y1,x2,col);
		goto hell;
	}
	if(!dx)
	{
		vline(bm,x1,y1,y2,col);
		goto hell;
	}
	if(dx==dy)
	{
		do
		{
			putpixel(bm,x1,y1,col);
			x1+=x_dir;
			y1++;
		} while(dy--);
		goto hell;
	}

	err=0;

	_blender_alpha=255;
	putpixel(bm,x1,y1,col);

	if(dy>dx)
	{
		err_delta=(dx<<16)/dy;
		while(--dy)
		{
			err_tmp=err;
			err+=err_delta;
			if(err<=err_tmp) x1+=x_dir;

			y1++;

			int alpha=err>>8;
			_blender_alpha=255-alpha;
			putpixel(bm,x1,y1,col);
			_blender_alpha=alpha;
			putpixel(bm,x1+x_dir,y1,col);
		}
	}
	else
	{
		err_delta=(dy<<16)/dx;
		while(--dx)
		{
			err_tmp=err;
			err+=err_delta;
			if(err<=err_tmp) y1++;

			x1+=x_dir;

			int alpha=err>>8;
			_blender_alpha=255-alpha;
			putpixel(bm,x1,y1,col);
			_blender_alpha=alpha;
			putpixel(bm,x1,y1+1,col);
		}
	}
	_blender_alpha=255;
	putpixel(bm,x2,y2,col);

	hell:
	bm->clip=clip;
	_blender_alpha=oldalpha;
}

void antialias_line8(BITMAP *bm,int x1,int y1,int x2,int y2,int colbase,int coloffs)
{
	int clip=bm->clip;

	if(clip&&x1>=bm->cl&&x1<bm->cr&&y1>=bm->ct&&y1<bm->cb&&
	x2>=bm->cl&&x2<bm->cr&&y2>=bm->ct&&y2<bm->cb) bm->clip=false;

	uint16 err,err_delta,err_tmp;
	uint32 dx,dy;
	int x_dir;

	if(y1>y2)
	{
		int tmp;
		tmp=y1; y1=y2; y2=tmp;
		tmp=x1; x1=x2; x2=tmp;
	}

	if(x2>x1) { x_dir=1; dx=x2-x1; }
	else { x_dir=-1; dx=x1-x2; }

	if(!(dy=y2-y1))
	{
		hline(bm,x1,y1,x2,colbase+coloffs);
		goto hell;
	}
	if(!dx)
	{
		vline(bm,x1,y1,y2,colbase+coloffs);
		goto hell;
	}
	if(dx==dy)
	{
		do
		{
			putpixel(bm,x1,y1,colbase+coloffs);
			x1+=x_dir;
			y1++;
		} while(dy--);
		goto hell;
	}

	err=0;

	putpixel(bm,x1,y1,colbase+coloffs);

	if(dy>dx)
	{
		err_delta=(dx<<16)/dy;
		while(--dy)
		{
			err_tmp=err;
			err+=err_delta;
			if(err<=err_tmp) x1+=x_dir;

			y1++;

			int intensity=(((coloffs+1)*err)>>16);
			putpixel(bm,x1,y1,colbase+coloffs-intensity);
			putpixel(bm,x1+x_dir,y1,colbase+intensity);
		}
	}
	else
	{
		err_delta=(dy<<16)/dx;
		while(--dx)
		{
			err_tmp=err;
			err+=err_delta;
			if(err<=err_tmp) y1++;

			x1+=x_dir;

			int intensity=(((coloffs+1)*err)>>16);
			putpixel(bm,x1,y1,colbase+coloffs-intensity);
			putpixel(bm,x1,y1+1,colbase+intensity);
		}
	}
	putpixel(bm,x2,y2,colbase+coloffs);

	hell:
	bm->clip=clip;
}



static bool clip_test(int n,int d,int &n1,int &d1,int &n2,int &d2)
{
	if(d<0)
	{
		if(n*d2<n2*d) return(false); // r>u2
		if(n*d1<n1*d) { n1=-n; d1=-d; } //r>u1
	}
	else if(d>0)
	{
		if(n*d1<n1*d) return(false); // r<u1
		if(n*d2<n2*d) { n2=n; d2=d; } // r<u2
	}
	else
	{
		if(n<0) return(false);
	}
	return(true);
}

bool clip_line(int &x1,int &y1,int &x2,int &y2,int left,int top,int right,int bottom)
{
	int n1=0,d1=1;
	int n2=1,d2=1;

	int dx=x2-x1;
	int dy=y2-y1;

	if(clip_test(x1-left,-dx,n1,d1,n2,d2))
	if(clip_test(right-x1,dx,n1,d1,n2,d2))
	if(clip_test(y1-top,-dy,n1,d1,n2,d2))
	if(clip_test(bottom-y1,dy,n1,d1,n2,d2))
	{
		if(n2<d2)
		{
			x2=x1+(n2*dx+SGN(dx)*d2/2)/d2;
			y2=y1+(n2*dy+SGN(dy)*d2/2)/d2;
		}
		if(n1>0)
		{
			x1=x1+(n1*dx+SGN(dx)*d1/2)/d1;
			y1=y1+(n1*dy+SGN(dy)*d1/2)/d1;
		}

		return(true);
	}

	return(false);
}
