#ifndef _GOA_LINE_INLINE_H_
#define _GOA_LINE_INLINE_H_

#include <math.h>

static inline void _init_shallow
(int &x_start,int &y_start,int &x_end,int &y_end,
double &slope,double &x,int &x_offs,const int dx,const int dy)
{
	slope=double(dx)/double(dy);
	x=x_start+slope*0.5+(dx<0?1:0); // duh?
	x_offs=dx>0?1:-1;
}

static inline void _init_steep
(int &x_start,int &y_start,int &x_end,int &y_end,
double &slope,double &y,int &x_offs,const int dx,const int dy)
{
	slope=SGN(dx)*double(dy)/double(dx);
	y=y_start+slope*0.5;
	x_offs=dx>0?1:-1;
}

static inline bool _clip_shallow
(int &x_start,int &y_start,int &x_end,int &y_end,
const double slope,double &x,const int x_offs,
const int dx,const int dy,const int w,const int h)
{
	int offs;

	if(!dy) // horizontal
	{
		if(dx>0)
		{
			if(x_start<0) x_start=0;
			if(x_end>=w) x_end=w-1;
		}
		else
		{
			if(x_start>=w) x_start=w-1;
			if(x_end<0) x_end=0;
		}
	}
	else
	{
		if(y_start<0) // clip top
		{
			x-=slope*y_start;
			x_start=int(x-slope)+x_offs;
			y_start=0;
		}

		if(y_end>=h) // clip bottom
		{
			y_end=h-1;
			x_end=int(x+slope*(y_end-y_start));
		}

		if(dx>0) // rightward
		{
			if(x_start>=w||x_end<0) return(false);

			if(x_start<0) // clip left
			{
				offs=int(floor(-x/slope))+1;
				y_start+=offs;
				x+=offs*slope;
				x_start=0;
			}

			if(x_end>=w) // clip right
			{
				offs=int(floor((w-x-1)/slope))+1;
				y_end=y_start+offs;
				x_end=w-1;
			}
		}
		else // leftward
		{
			if(x_start<0||x_end>=w) return(false);

			if(x_start>=w) // clip right
			{
				offs=int(floor((w-x)/slope))+1;
				y_start+=offs;
				x+=offs*slope;
				x_start=w-1;
			}

			if(x_end<0) // clip left
			{
				offs=int(floor((1-x)/slope))+1;
				y_end=y_start+offs;
				x_end=0;
			}
		}
	}
	return(true);
}

static inline bool _clip_steep
(int &x_start,int &y_start,int &x_end,int &y_end,
const double slope,double &y,const int x_offs,
const int dx,const int dy,const int w,const int h)
{
	int offs;

	if(!dx) // vertical
	{
		if(y_start<0) y_start=0;
		if(y_end>=h) y_end=h-1;
	}
	else
	{
		if(dx>0) // rightward
		{
			if(x_start<0) // clip left
			{
				y-=slope*x_start;
				y_start=int(y-slope)+1;
				x_start=0;
			}

			if(x_end>=w) // clip right
			{
				x_end=w-1;
				y_end=int(y+slope*(x_end-x_start));
			}
		}
		else // leftward
		{
			if(x_start>=w) // clip right
			{
				y+=slope*(x_start-w+1);
				y_start=int(y-slope)+1;
				x_start=w-1;
			}

			if(x_end<0) // clip left
			{
				x_end=0;
				y_end=int(y+slope*x_start);
			}
		}

		if(y_start>=h||y_end<0) return(false);

		if(y_start<0)
		{
			offs=int(floor(-y/slope))+1;
			x_start+=offs*SGN(dx);
			y+=offs*slope;
			y_start=0;
		}

		if(y_end>=h)
		{
			offs=int(floor((h-y-1)/slope))+1;
			x_end=x_start+offs*SGN(dx);
			y_end=h-1;
		}
	}
	return(true);
}

#endif
