#include <stdio.h>
#include <dirent.h>
#include <string.h>
#include <allegro.h>

#include <goa/menu.h>
#include <goa/bitmap.h>
#include <goa/input.h>
#include <goa/blend.h>



char *clonestr(const char *str);



m_menulook m_look;



m_menulook::m_menulook()
{
	ncol=fcol=pcol=icol=0;
	f=font;
}

int m_menulook::find_col(g_gadget *g)
{
	if(g->get_flag(GUIFLAG_PRESSED)) return(pcol);
	if(g->get_flag(GUIFLAG_FOCUSED)) return(fcol);
	if(!g->get_flag(GUIFLAG_ACTIVE)) return(icol);
	return(ncol);
}



// m_menu

m_menu::m_menu():g_gridgroup(1,false,false)
{
	vspace=1;
}

m_menu::m_menu(g_gadget **contents):g_gridgroup(1,false,false)
{
	vspace=1;

	insert(contents);
}

m_menu::m_menu(g_gadget *first,...):g_gridgroup(1,false,false)
{
	vspace=1;
	insert_va(first);
}

void m_menu::calc_sizes()
{
	g_gridgroup::calc_sizes();

	maxwidth=minwidth;
	maxheight=minheight;

/*	int ly=0;

	g_group::calc_sizes();

	iterator i(&children);
	g_gadget *g;

	width=height=0;
	while(g=(g_gadget *)i.step())
	{
		width=MAX(width,g->width);
		height+=g->height+vspace;
	}
	height-=vspace;

	i.restart();
	while(g=(g_gadget *)i.step())
	{
		g->calc_placing(frame->left,ly+frame->top,width,g->height);

		ly+=g->height+vspace;
	}

	width+=frame->left+frame->right;
	height+=frame->top+frame->bottom;
	*/
}

bool m_menu::key(int c,int k)
{
	if(g_group::key(c,k)) return(true);

	switch(k)
	{
		case KEY_UP:
			return(focus_prev(true));

		case KEY_DOWN:
			return(focus_next(true));
	}
	return(false);
}



// m_menuet

m_menuet::m_menuet(int event,m_menulook *look):g_gadget()
{
	ev=event;
	l=look?look:&m_look;
}



// m_text

m_text::m_text(const char *title,int event,m_menulook *look):m_menuet(event,look)
{
	t=clonestr(title);

	set_flag(GUIFLAG_CLICKABLE);
}

m_text::~m_text()
{
	delete t;
}

void m_text::calc_sizes()
{
	m_menuet::calc_sizes();

	minwidth+=text_length(l->f,t);
	minheight+=text_height(l->f);
	maxwidth=GUI_NO_MAX_SIZE;
	maxheight=minheight;
}

void m_text::draw(BITMAP *bm,int x,int y,int w,int h)
{
	m_menuet::draw(bm,x,y,w,h);

	text_mode(-1);
	textout(bm,l->f,t,x+(w-minwidth)/2+frame->left,y+frame->top,l->find_col(this));
}



// m_label

m_label::m_label(const char *title,m_menulook *look):m_text(title,0,look)
{
	clear_flag(GUIFLAG_ACTIVE);
}



// m_dual

m_dual::m_dual(const char *left,const char *right,m_menulook *look):m_menuet(0,look)
{
	leftstr=clonestr(left);
	if(right) rightstr=rightfree=clonestr(right);
	else rightstr=rightfree=0;

	space=2;
	rightwidth=0;
}

m_dual::~m_dual()
{
	delete leftstr;
	delete rightfree;
}

void m_dual::calc_sizes()
{
	m_menuet::calc_sizes();

	minwidth+=text_length(l->f,leftstr);
	minheight+=text_height(l->f);

	if(rightwidth) minwidth+=rightwidth+space;
	else if(rightstr) minwidth+=text_length(l->f,rightstr)+space;

	maxwidth=GUI_NO_MAX_SIZE;
	maxheight=minheight;
}

void m_dual::draw(BITMAP *bm,int x,int y,int w,int h)
{
	m_menuet::draw(bm,x,y,w,h);

	text_mode(-1);

	x+=frame->left; y+=frame->top;
	textout(bm,l->f,leftstr,x,y,l->find_col(this));
	if(rightstr) textout_right(bm,l->f,rightstr,x+w-1-frame->right,y,l->find_col(this));
}



// m_multi

m_multi::m_multi(const char *title,m_menulook *look,const char *first,...):m_dual(title,0,look)
{
	va_list v;
	char *str;

	i=0;

	for(n=1,va_start(v,first);va_arg(v,char *);n++);
	va_end(v);

	c=new char *[n];
	n=0;

	insert(first);
	va_start(v,first);
	for(int j=1;str=va_arg(v,char *);j++) insert(str);
	va_end(v);

	set_flag(GUIFLAG_CLICKABLE);
}

m_multi::m_multi(const char *title,m_menulook *look,int num):m_dual(title,0,look)
{
	i=n=0;

	c=new char *[num];

	set_flag(GUIFLAG_CLICKABLE);
}

m_multi::~m_multi()
{
	for(int j=0;j<n;j++) delete c[j];
	delete c;
}

void m_multi::draw(BITMAP *bm,int x,int y,int w,int h)
{
	if(i<0||i>=n) rightstr=0;
	else rightstr=c[i];

	m_dual::draw(bm,x,y,w,h);
}

bool m_multi::key(int c,int k)
{
	switch(k)
	{
		case KEY_RIGHT:
		case KEY_PGDN:
			select_next();
			return(true);

		case KEY_LEFT:
		case KEY_PGUP:
			select_prev();
			return(true);
	}
	return(m_dual::key(c,k));
}

void m_multi::trigger(int type)
{
	select_next();
}

void m_multi::insert(const char *entry)
{
	c[n++]=clonestr(entry);

	int w=text_length(l->f,entry);
	rightwidth=MAX(rightwidth,w);
}

void m_multi::select_next()
{
	i=(i+1)%n;
	redraw();
}

void m_multi::select_prev()
{
	i=(i+n-1)%n;
	redraw();
}



// m_key

m_key::m_key(const char *title,int defkey,m_menulook *look):m_dual(title,0,look)
{
	k=defkey;
	reading=false;

	init_descriptions();

	for(int i=0;i<KEY_MAX;i++)
	{
		int w=text_length(l->f,key_description[i]);
		rightwidth=MAX(rightwidth,w);
	}

	set_flag(GUIFLAG_CLICKABLE);
}

void m_key::draw(BITMAP *bm,int x,int y,int w,int h)
{
	if(reading) rightstr="?";
	else rightstr=key_description[k];

	m_dual::draw(bm,x,y,w,h);
}

bool m_key::key(int c,int k)
{
	if(reading)
	{
		m_key::k=k;
		reading=false;
		redraw();
		return(true);
	}
	else return(m_dual::key(c,k));
}

void m_key::trigger(int type)
{
	reading=true;
	redraw();
}



// m_string

m_string::m_string(const char *title,int textsize,int maxlen,int event,m_menulook *look):m_menuet(event,look)
{
	t=clonestr(title);
	size=textsize;
	len=maxlen;

	str=new char[len+1];
	for(int i=0;i<len;i++) str[i]=0;
	pos=0;

	space=2;
}

m_string::~m_string()
{
	delete t;
	delete str;
}

void m_string::calc_sizes()
{
	m_menuet::calc_sizes();

	minwidth+=text_length(l->f,t)+space+size;
	minheight+=text_height(l->f);
	maxwidth=GUI_NO_MAX_SIZE;
	maxheight=minheight;
}

void m_string::draw(BITMAP *bm,int x,int y,int w,int h)
{
	m_menuet::draw(bm,x,y,w,h);

	text_mode(-1);

	x+=frame->left; y+=frame->top;
	textout(bm,l->f,t,x,y,l->find_col(this));

	set_clip(bm,x+text_length(l->f,t),y,x+w-1,y+h-1);
	textout_right(bm,l->f,str,x+w-1-frame->right,y,l->find_col(this));
	set_clip(bm,0,0,bm->w-1,bm->h-1);
}

bool m_string::key(int c,int k)
{
	if(k==KEY_BACKSPACE)
	{
		if(pos)
		{
			for(int i=pos;i<=len;i++) str[i-1]=str[i];
			pos--;

			redraw();

			return(true);
		}
	}
	else if(k==KEY_ENTER)
	{
		return(m_menuet::key(c,k));
	}

	if(pos<len)
	{
		if(c<32||c>126) return(false);

		for(int i=pos+1;i<=len;i++) str[i]=str[i-1];
		str[pos]=c;

		pos++;

		redraw();

		return(true);
	}

	return(false);
}



// m_filemenu

static int comp_entries(const void *m1,const void *m2)
{
	int res=0;
	for(char *s=(*(m_text **)m1)->t;*s;s++) if(*s==OTHER_PATH_SEPARATOR) { res++; break; }
	for(char *s=(*(m_text **)m2)->t;*s;s++) if(*s==OTHER_PATH_SEPARATOR) { res--; break; }

	if(res) return(res);
	else return(strcmp((*(m_text **)m1)->t,(*(m_text **)m2)->t));
}

m_filemenu::m_filemenu(char *dir):m_menu()
{
	m_text *entries[MENU_FILEMENU_MAXFILES+1];
	int n=0;

	scandir(dir,"",entries,n);
	entries[n]=0;

	qsort(entries,n,sizeof(m_text *),comp_entries);

	insert((g_gadget **)entries); // why do I need to cast anyway?
}

void m_filemenu::event(int event)
{
	if(event==1) strcpy(filename,((m_text *)focus)->t);
	m_menu::event(event);
}

void m_filemenu::scandir(char *dir,char *prefix,m_text **array,int &n)
{
	DIR *d;
	FILE *fh;
	dirent *e;
	char str[MENU_FILEMENU_MAXSTRLEN],prevdir[MENU_FILEMENU_MAXSTRLEN];

	getcwd(prevdir,MENU_FILEMENU_MAXSTRLEN);
	chdir(dir);

	if(d=opendir("."))
	{
		while((e=readdir(d))&&n<MENU_FILEMENU_MAXFILES)
		if(e->d_name[0]!='.')
		{
			strcpy(str,prefix);
			strcat(str,e->d_name);
			fh=fopen(e->d_name,"r");

			//if(access(e->d_name,D_OK))
			if(fh) { fclose(fh); array[n++]=new m_text(str,1,0); }
			else
			{
				int offs=strlen(str);
				str[offs]=OTHER_PATH_SEPARATOR;
				str[offs+1]=0;
				scandir(e->d_name,str,array,n);
			}
		}

		closedir(d);
	}

	chdir(prevdir);
}



// m_skinmenu

m_skinframe::m_skinframe():g_frame()
{
	for(int i=0;i<10;i++) part[i]=0;
	tmp=0;
}

m_skinframe::~m_skinframe()
{
	for(int i=0;i<10;i++) destroy_bitmap(part[i]);
	destroy_bitmap(tmp);
}

void m_skinframe::draw_normal(BITMAP *bm,int x1,int y1,int x2,int y2)
{
	void (*draw_part)(BITMAP *dest,BITMAP *part,int x,int y);
	int x_titledraw,y_titledraw;

	draw_part=bitmap_color_depth(screen)==8?draw_sprite:draw_trans_sprite;

	if(part[9])
	{
		switch(place_title&GUIPLACE_HORIZ_MASK)
		{
			case GUIPLACE_CENTER:
				x_titledraw=(x2-x1+1-part[9]->w)/2+x_title;
			break;

			case GUIPLACE_LEFT:
				x_titledraw=x_title;
			break;

			case GUIPLACE_RIGHT:
				x_titledraw=x2+1-part[9]->w+x_title;
			break;

			case GUIPLACE_CENTER_CONTENTS:
				x_titledraw=(x2-x1+1-left-right-part[9]->w)/2+left+x_title;
			break;
		}

		switch(place_title&GUIPLACE_VERT_MASK)
		{
			case GUIPLACE_MIDDLE:
				y_titledraw=(y2-y1+1-part[9]->h)/2+y_title;
			break;

			case GUIPLACE_TOP:
				y_titledraw=y_title;
			break;

			case GUIPLACE_BOTTOM:
				y_titledraw=y2+1-part[9]->h+y_title;
			break;

			case GUIPLACE_MIDDLE_CONTENTS:
				y_titledraw=(y2-y1+1-top-bottom-part[9]->h)/2+top+y_title;
			break;
		}

		if(tmp)
		{
			blit(bm,tmp,x1+x_titledraw,y1+y_titledraw,0,0,tmp->w,tmp->h);
		}
	}

	if(part[0]) // bah
	{
		int fillwidth=x2-x1+1-skinleft-skinright;
		int fillheight=y2-y1+1-skintop-skinbottom;
		BITMAP *sub;

//		set_fast_trans_blender(0,0,0);
		set_fast_trans_blender_75(0,0,0);

		draw_part(bm,part[0],x1,y1);
		draw_part(bm,part[2],x2-skinright+1,y1);
		draw_part(bm,part[6],x1,y2-skinbottom+1);
		draw_part(bm,part[8],x2-skinright+1,y2-skinbottom+1);

		sub=create_sub_bitmap(bm,x1+skinleft,y1,fillwidth,y2-y1+1);
		for(int bx=0;bx<fillwidth;bx+=part[1]->w)
		{
			draw_part(sub,part[1],bx,0);
			draw_part(sub,part[7],bx,skintop+fillheight);
		}
		destroy_bitmap(sub);

		sub=create_sub_bitmap(bm,x1,y1+skintop,x2-x1+1,fillheight);
		for(int by=0;by<fillheight;by+=part[3]->h)
		{
			draw_part(sub,part[3],0,by);
			draw_part(sub,part[5],skinleft+fillwidth,by);
		}
		destroy_bitmap(sub);

		sub=create_sub_bitmap(bm,x1+skinleft,y1+skintop,fillwidth,fillheight);
		for(int bx=0;bx<fillwidth;bx+=part[4]->w)
		for(int by=0;by<fillheight;by+=part[4]->h)
		{
			draw_part(sub,part[4],bx,by);
		}
		destroy_bitmap(sub);
	}

	if(part[9])
	{
		if(tmp)
		{
			draw_part(tmp,part[9],0,0);
			blit(tmp,bm,0,0,x1+x_titledraw,y1+y_titledraw,tmp->w,tmp->h);
		}
		else
		{
			draw_part(bm,part[9],x1+x_titledraw,y1+y_titledraw);
		}
	}
}

void m_skinframe::draw_focused(BITMAP *bm,int x1,int y1,int x2,int y2)
{
	draw_normal(bm,x1,y1,x2,y2);
}

void m_skinframe::draw_pressed(BITMAP *bm,int x1,int y1,int x2,int y2)
{
	draw_normal(bm,x1,y1,x2,y2);
}

void m_skinframe::draw_inactive(BITMAP *bm,int x1,int y1,int x2,int y2)
{
	draw_normal(bm,x1,y1,x2,y2);
}


void m_skinframe::load_skin(char *skinfile,int sl,int sr,int st,int sb,int l,int r,int t,int b)
{
	BITMAP *skin=load_any_bitmap(skinfile);

	part[0]=create_bitmap(sl,st); blit(skin,part[0],0,0,0,0,sl,st);
	part[1]=create_bitmap(skin->w-sl-sr,st); blit(skin,part[1],sl,0,0,0,skin->w-sl-sr,st);
	part[2]=create_bitmap(sr,st); blit(skin,part[2],skin->w-sr,0,0,0,sr,st);

	part[3]=create_bitmap(sl,skin->h-st-sb); blit(skin,part[3],0,st,0,0,sl,skin->h-st-sb);
	part[4]=create_bitmap(skin->w-sl-sr,skin->h-st-sb); blit(skin,part[4],sl,st,0,0,skin->w-sl-sr,skin->h-st-sb);
	part[5]=create_bitmap(sr,skin->h-st-sb); blit(skin,part[5],skin->w-sr,st,0,0,sr,skin->h-st-sb);

	part[6]=create_bitmap(sl,sb); blit(skin,part[6],0,skin->h-sb,0,0,sl,sb);
	part[7]=create_bitmap(skin->w-sl-sr,sb); blit(skin,part[7],sl,skin->h-sb,0,0,skin->w-sl-sr,sb);
	part[8]=create_bitmap(sr,sb); blit(skin,part[8],skin->w-sr,skin->h-sb,0,0,sr,sb);

	destroy_bitmap(skin);

	skinleft=sl;
	skinright=sr;
	skintop=st;
	skinbottom=sb;
	left=l;
	right=r;
	top=t;
	bottom=b;
}

void m_skinframe::load_title(char *titlefile,int x,int y,int p)
{
	part[9]=load_any_bitmap(titlefile);
	tmp=create_bitmap(part[9]->w,part[9]->h);

	x_title=x;
	y_title=y;
	place_title=p;
}



char *clonestr(const char *str)
{
	char *res=new char[strlen(str)+1];
	if(res) strcpy(res,str);
	return(res);
}
