#include <stdlib.h>
#include <goa/ifftools.h>




// chunk

chunk::chunk(chunk *n,int p,bool m)
{ next=n; pos=p; mini=m; }



// iffreader

iffreader::iffreader() // blah
{
	id=0;
	filesize=0;
	fh=0;
	chunks=0;
}

iffreader::iffreader(char *filename)
{
	chunks=0;
	if(fh=fopen(filename,"rb"))
	{
		if(readint32()==ID_FORM)
		{
			chunks=new chunk(0,readint32()+8);
			id=readint32();
			startsubchunks();
			return;
		}
		fclose(fh);
		fh=0;
	}
}

iffreader::iffreader(FILE *fileh)
{
	chunks=0;
	if(fh=fileh)
	{
		if(readint32()==ID_FORM)
		{
			chunks=new chunk(0,readint32()+8);
			id=readint32();
			startsubchunks();
			return;
		}
		fclose(fh);
		fh=0;
	}
}

iffreader::iffreader(char *filename,int32 wantid)
{
	chunks=0;
	id=wantid;
	if(fh=fopen(filename,"rb"))
	{
		if(readint32()==ID_FORM)
		{
			chunks=new chunk(0,readint32()+8);
			if(readint32()==id)
			{
				startsubchunks();
				return;
			}
		}
		fclose(fh);
		fh=0;
	}
}

iffreader::iffreader(FILE *fileh,int32 wantid)
{
	chunks=0;
	id=wantid;
	if(fh=fileh)
	{
		if(readint32()==ID_FORM)
		{
			chunks=new chunk(0,readint32()+8);
			if(readint32()==id)
			{
				startsubchunks();
				return;
			}
		}
		fclose(fh);
		fh=0;
	}
}

iffreader::~iffreader()
{
	if(fh)
	{
		while(chunks) endsubchunks();
		fclose(fh);
	}
}

bool iffreader::isvalid() { return(fh&&chunks?true:false); }

bool iffreader::startsubchunks()
{
	chunks=new chunk(chunks,ftell(fh));
	return(true);
}

bool iffreader::endsubchunks()
{
	if(!chunks) return(false); // underflow
	chunk *n=chunks->next;
	delete chunks;
	chunks=n;

	return(true);
}

int32 iffreader::nextchunk(int &size)
{
	int32 id;

	if(!chunks||!chunks->next||chunks->pos>=chunks->next->pos) return(0);

	fseek(fh,chunks->pos,SEEK_SET);

	id=readint32();
	size=readint32();
	chunks->pos=ftell(fh)+size+(size&1);

	return(id);
}

int32 iffreader::nextminichunk(int &size)
{
	int32 id;

	if(!chunks||!chunks->next||chunks->pos>=chunks->next->pos) return(0);

	fseek(fh,chunks->pos,SEEK_SET);

	id=readint32();
	size=readint16();
	chunks->pos=ftell(fh)+size+(size&1);

	return(id);
}

bool iffreader::readstr(char *str,int maxlen)
{
	exit(666); // not implemented
}

bool iffreader::read(void *data,int size)
{
	fread(data,size,1,fh);
	return(true);
}

int8 iffreader::readint8()
{ return(fgetc(fh)); }

uint8 iffreader::readuint8()
{ return(fgetc(fh)); }

int16 iffreader::readint16()
{ return((fgetc(fh)<<8)+fgetc(fh)); }

uint16 iffreader::readuint16()
{ return((fgetc(fh)<<8)+fgetc(fh)); }

int32 iffreader::readint32()
{ return((fgetc(fh)<<24)+(fgetc(fh)<<16)+(fgetc(fh)<<8)+fgetc(fh)); }

uint32 iffreader::readuint32()
{ return((fgetc(fh)<<24)+(fgetc(fh)<<16)+(fgetc(fh)<<8)+fgetc(fh)); }

float iffreader::readfloat()
{
	int32 tmp=readint32();
	return(*((float *)&tmp));
}



// iffwriter

iffwriter::iffwriter()
{
	fh=0;
	chunks=0;
}

iffwriter::iffwriter(char *filename,int32 id)
{
	chunks=0;
	if(fh=fopen(filename,"wb"))
	{
		writeint32(ID_FORM);
		writeint32(0);
		writeint32(id);
	}
}

iffwriter::iffwriter(FILE *fileh,int32 id)
{
	chunks=0;
	if(fh=fileh)
	{
		writeint32(ID_FORM);
		writeint32(0);
		writeint32(id);
	}
}

iffwriter::~iffwriter()
{
	if(fh)
	{
		while(chunks) endchunk();
		int size=ftell(fh);
		fseek(fh,4,SEEK_SET);
		writeint32(size-8);
		fclose(fh); // if() needed?
	}
}

bool iffwriter::isvalid() { return(fh?true:false); }

bool iffwriter::startchunk(int32 id)
{
	writeint32(id);
	chunks=new chunk(chunks,ftell(fh),false);
	writeint32(0);
	return(true); // heh. great errorchecking.
}

bool iffwriter::startminichunk(int32 id)
{
	writeint32(id);
	chunks=new chunk(chunks,ftell(fh),true);
	writeint16(0);
	return(true); // heh. great errorchecking.
}

bool iffwriter::endchunk()
{
	int pos=ftell(fh);
	chunk *c=chunks;
	if(!c) return(false); // underflow
	chunks=chunks->next;

	if(pos&1) fputc(0,fh);

	fseek(fh,c->pos,SEEK_SET);
	if(c->mini) writeint16(pos-c->pos-2);
	else writeint32(pos-c->pos-4);
	fseek(fh,pos+(pos&1),SEEK_SET);

	delete c;

	return(true);
}

bool iffwriter::write(void *data,int size)
{
	fwrite(data,size,1,fh);
	return(true);
}

bool iffwriter::writestr(char *str)
{
	fputs(str,fh);
	fputc(0,fh);
	return(true);
}

bool iffwriter::writeint8(int8 n)
{ fputc(n,fh); return(true); }

bool iffwriter::writeuint8(uint8 n)
{ fputc(n,fh); return(true); }

bool iffwriter::writeint16(int16 n)
{ fputc(n>>8,fh); fputc(n&0xff,fh); return(true); }

bool iffwriter::writeuint16(uint16 n)
{ fputc(n>>8,fh); fputc(n&0xff,fh); return(true); }

bool iffwriter::writeint32(int32 n)
{ fputc(n>>24,fh); fputc((n>>16)&0xff,fh); fputc((n>>8)&0xff,fh); fputc(n&0xff,fh); return(true); }

bool iffwriter::writeuint32(uint32 n)
{ fputc(n>>24,fh); fputc((n>>16)&0xff,fh); fputc((n>>8)&0xff,fh); fputc(n&0xff,fh); return(true); }

bool iffwriter::writefloat(float f)
{
	return(writeint32(*((int32 *)&f)));
}

#ifdef TEST
int main(void)
{
	iffwriter iff("test.iff",MAKE_ID('T','E','S','T'));
	iff.pushchunk(MAKE_ID('S','U','G','!'));
	iff.write("Doidydoidydoidy!",17);
	iff.popchunk();
	iff.pushchunk(MAKE_ID('K','U','K','!'));
	iff.write("Beablebeablebeable",18);
	iff.popchunk();
	return(0);
}
#endif

