#ifndef _GOA_IFFTOOLS_H_
#define _GOA_IFFTOOLS_H_

#include <stdio.h>
#include <goa/types.h>

#define MAKE_ID(a,b,c,d) (((a)<<24)+((b)<<16)+((c)<<8)+((d)<<0))

#define ID_FORM MAKE_ID('F','O','R','M')


class chunk
{
	public:
	chunk(chunk *n,int p,bool m=false);

	chunk *next;
	int pos;
	bool mini;
};

class iffreader
{
	public:
	iffreader();
	iffreader(char *filename);
	iffreader(FILE *file);
	iffreader(char *filename,int32 wantid);
	iffreader(FILE *file,int32 wantid);
	~iffreader();

	bool isvalid();

	bool startsubchunks();
	bool endsubchunks();
	int32 nextchunk(int &size);
	int32 nextminichunk(int &size);

	bool read(void *data,int size);
	bool readstr(char *str,int maxlen);
	int8 readint8();
	uint8 readuint8();
	int16 readint16();
	uint16 readuint16();
	int32 readint32();
	uint32 readuint32();
	float readfloat();

	int32 id;
	int filesize;

	FILE *fh;
	chunk *chunks;
};

class iffwriter
{
	public:
	iffwriter();
	iffwriter(char *filename,int32 id);
	iffwriter(FILE *file,int32 id);
	~iffwriter();

	bool isvalid();

	bool startchunk(int32 id);
	bool startminichunk(int32 id);
	bool endchunk();

	bool write(void *data,int size);
	bool writestr(char *str);
	bool writeint8(int8 n);
	bool writeuint8(uint8 n);
	bool writeint16(int16 n);
	bool writeuint16(uint16 n);
	bool writeint32(int32 n);
	bool writeuint32(uint32 n);
	bool writefloat(float f);

	FILE *fh;
	chunk *chunks;
};

#endif
