#ifndef _GOA_LIST_H_
#define _GOA_LIST_H_

class node
{
	public:
	node();
	virtual ~node();

	void add_after(node *before);
	void remove();

	node *next,*prev;
};

class list
{
	public:
	list();
	~list();

	void add_head(node *entry);
	void add_tail(node *entry);
	void add_head(list *lst);
	void add_tail(list *lst);

	node *find(int n);
	bool exists(node *n);
	bool empty();
	int count();
	void clear();

	node sentinel;
};



class iterator
{
	public:
	iterator();
	iterator(list *lst);
	iterator(list *lst,node *here);

	void start(list *lst);
	void start(list *lst,node *here);
	void start(node *here);
	void restart();
	node *step();
	node *peek();

	node *next,*stop;
};

class reverseiterator
{
	public:
	reverseiterator();
	reverseiterator(list *lst);
	reverseiterator(list *lst,node *here);

	void start(list *lst);
	void start(list *lst,node *here);
	void start(node *here);
	void restart();
	node *step();
	node *peek();

	node *prev,*stop;
};




template <class entry> class arraybuilder
{
	public:
	arraybuilder();

	void add(entry e);

	entry *get_array();
	entry *get_array(int &size);

	entry *get_nullterm_array();

	void clear();

	struct entrynode:public node
	{
		public:
		entrynode();
		entrynode(entry &ent);

		entry e;
	};

	list l;
};

template <class entry> arraybuilder<entry>::arraybuilder()
{
}

template <class entry> void arraybuilder<entry>::add(entry e)
{
//printf("yaaah10\n"); fflush(stdout);
	l.add_tail(new entrynode(e));
//printf("yaaah11\n"); fflush(stdout);
}

template <class entry> entry *arraybuilder<entry>::get_array()
{
	int dummy;
	return(get_array(dummy));
}

template <class entry> entry *arraybuilder<entry>::get_array(int &size)
{
	size=l.count();

	if(!size) return(0);

	entry *array=new entry[size];
	entry *ptr=array;

	iterator i(&l);
	entrynode *en;
	while(en=(entrynode *)i.step()) *ptr++=en->e;

	return(array);
}

template <class entry> entry *arraybuilder<entry>::get_nullterm_array()
{
	int size=l.count();

	if(!size) return(0);

	entry *array=new entry[size+1];
	entry *ptr=array;

	iterator i(&l);
	entrynode *en;
	while(en=(entrynode *)i.step()) *ptr++=en->e;
	*ptr=0;

	return(array);
}

template <class entry> void arraybuilder<entry>::clear()
{
	l.clear();
}

template <class entry> arraybuilder<entry>::entrynode::entrynode():node() {}

template <class entry> arraybuilder<entry>::entrynode::entrynode(entry &ent):node(),e(ent) {}



#endif

