#ifndef _GOA_MENU_H_
#define _GOA_MENU_H_

#include "gui.h"



class m_menuet;

class m_menulook
{
	public:
	m_menulook();

	int find_col(g_gadget *g);

	FONT *f;
	int ncol,fcol,pcol,icol;
};

extern m_menulook m_look;



class m_menu:public g_gridgroup
{
	public:
	m_menu();
	m_menu(g_gadget **contents);
	m_menu(g_gadget *first,...);

	void calc_sizes();
	bool key(int c,int k);

//	int vspace;
};



class m_menuet:public g_gadget
{
	public:
	m_menuet(int event=0,m_menulook *look=0);

	m_menulook *l;
};

class m_text:public m_menuet
{
	public:
	m_text(const char *title,int event=0,m_menulook *look=0);
	~m_text();

	void calc_sizes();
	void draw(BITMAP *bm,int x,int y,int w,int h);

	char *t;
};

class m_label:public m_text
{
	public:
	m_label(const char *title,m_menulook *look=0);
};

class m_dual:public m_menuet
{
	public:
	m_dual(const char *left,const char *right,m_menulook *look=0);
	~m_dual();

	void calc_sizes();
	void draw(BITMAP *bm,int x,int y,int w,int h);

	char *leftstr,*rightstr,*rightfree;
	int space,rightwidth;
};

class m_multi:public m_dual
{
	public:
	m_multi(const char *title,m_menulook *look,const char *first,...);
	m_multi(const char *title,m_menulook *look,int num);
	~m_multi();

	void draw(BITMAP *bm,int x,int y,int w,int h);
	bool key(int c,int k);
	void trigger(int type);

	void insert(const char *entry);
	void select_next();
	void select_prev();

	int n,i;
	char *t,**c;
};

class m_key:public m_dual
{
	public:
	m_key(const char *title,int defkey,m_menulook *look=0);

	void draw(BITMAP *bm,int x,int y,int w,int h);
	bool key(int c,int k);
	void trigger(int type);

	int k;
	bool reading;
};

class m_string:public m_menuet
{
	public:
	m_string(const char *title,int textsize,int maxlen,int event=0,m_menulook *look=0);
	~m_string();

	void calc_sizes();
	void draw(BITMAP *bm,int x,int y,int w,int h);
	bool key(int c,int k);

	int size,len,pos,space;
	char *t,*str;
};

/*class m_spacer:public m_menuet
{
	public:
	m_spacer(int spacing);
};*/


#define MENU_FILEMENU_MAXFILES 256
#define MENU_FILEMENU_MAXSTRLEN 1024

class m_filemenu:public m_menu
{
	public:
	m_filemenu(char *dir);

	void event(int event);

	char filename[MENU_FILEMENU_MAXSTRLEN];

	private:
	void scandir(char *dir,char *prefix,m_text **array,int &n);
};



class m_skinframe:public g_frame
{
	public:
	m_skinframe();
	~m_skinframe();

	void draw_normal(BITMAP *bm,int x1,int y1,int x2,int y2);
	void draw_focused(BITMAP *bm,int x1,int y1,int x2,int y2);
	void draw_pressed(BITMAP *bm,int x1,int y1,int x2,int y2);
	void draw_inactive(BITMAP *bm,int x1,int y1,int x2,int y2);

	void load_skin(char *skinfile,int sl,int sr,int st,int sb,int l,int r,int t,int b);
	void load_title(char *titlefile,int x,int y,int p);

	BITMAP *part[10],*tmp;
	int skinleft,skinright,skintop,skinbottom;
	int x_title,y_title,place_title;
};


/*
class m_image:public menuet
{
	public:
	m_image(char *normal,char *active,char *inactive);
	m_image(BITMAP *normal,BITMAP *active,BITMAP *inactive);
	~m_image();

	void draw(BITMAP *bm,int x,int y,int w,int h,bool focus);

	BITMAP *n,*a,*i;
};

*/
#endif
