#include <goa/allegro.h>
#include <goa/input.h>

int main()
{
	PALETTE pal;

	if(allegro_init()) die("allegro_init() failed");
	if(install_mouse()==-1) die("install_mouse() failed");
	install_timer();
	install_keyboard();

	set_color_depth(8);
	if(set_gfx_mode(GFX_AUTODETECT,80,80,0,0)<0) die("Screen mode not supported");
//	set_color_depth(16);
//	if(set_gfx_mode(GFX_AUTODETECT,640,480,0,0)<0) die("Screen mode not supported");

	BITMAP *bm=create_bitmap(SCREEN_W,SCREEN_H);
	BITMAP *spr=load_bitmap("test.pcx",pal);
	pal[0].r=pal[0].g=pal[0].b=0;
	set_palette(pal);
	RLE_SPRITE *rle=get_rle_sprite(spr);
	destroy_bitmap(spr);

	int midx=SCREEN_W/2,midy=SCREEN_H/2;

	while(!keydown())
	{
		clear_bitmap(bm);
		rect(bm,SCREEN_W/4,SCREEN_H/4,SCREEN_W/4+SCREEN_W/2-1,SCREEN_H/4+SCREEN_H/2-1,makecol(127,255,127));

		draw_rle_sprite(bm,rle,SCREEN_W/2,SCREEN_H/2);

		putpixel(bm,midx+1,midy,makecol(127,127,0));
		putpixel(bm,midx-1,midy,makecol(127,127,0));
		putpixel(bm,midx,midy+1,makecol(127,127,0));
		putpixel(bm,midx,midy-1,makecol(127,127,0));

		putpixel(bm,mouse_x+1,mouse_y,makecol(127,127,0));
		putpixel(bm,mouse_x-1,mouse_y,makecol(127,127,0));
		putpixel(bm,mouse_x,mouse_y+1,makecol(127,127,0));
		putpixel(bm,mouse_x,mouse_y-1,makecol(127,127,0));

		fast_line(bm,midx,midy,mouse_x,mouse_y,makecol(127,127,127));

		set_clip(bm,SCREEN_W/4,SCREEN_H/4,SCREEN_W/4+SCREEN_W/2-1,SCREEN_H/4+SCREEN_H/2-1);
		fast_line(bm,midx,midy,mouse_x,mouse_y,makecol(255,255,255));
		set_clip(bm,0,0,SCREEN_W-1,SCREEN_H-1);

		if(collide_rle_line(rle,SCREEN_W/2,SCREEN_H/2,
		midx,midy,mouse_x,mouse_y)) textout(bm,font,"Line collide",0,0,makecol(127,127,255));

		if(collide_rle_point(rle,SCREEN_W/2,SCREEN_H/2,
		mouse_x,mouse_y)) textout(bm,font,"Point collide",0,10,makecol(255,127,127));

		blit(bm,screen,0,0,0,0,SCREEN_W,SCREEN_H);

		int mx=mouse_x,my=mouse_y;
		while(mx==mouse_x&&my==mouse_y&&!mouse_b&&!keydown());

		if(mouse_b) { midx=mouse_x; midy=mouse_y; }

	}

	destroy_bitmap(bm);
	destroy_rle_sprite(rle);
}

END_OF_MAIN();
