#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <allegro.h>

#include <goa/allegro.h>
#include <goa/menu.h>
#include <goa/gui.h>



#define WIDTH 800
#define HEIGHT 600



enum
{
	FONT_LED_KATAKANA_7,
	FONT_LED_ROMAN_7,
	FONT_MACAQUE_11,
	FONT_MACAQUE_8,
	FONT_MACAQUE_THIN_11,
	FONT_SMALL_8,
	FONT_TERMINALDISEASE_11,
	FONT_WOMBAT_11,
	FONT_WOMBAT_THIN_10,
	FONT_NUM
};

FONT *amigafont;



void stuff()
{
	m_look.f=amigafont;
	m_look.ncol=makecol(255,255,0);
	m_look.fcol=makecol(255,255,255);
	m_look.pcol=makecol(255,0,0);
	m_look.icol=makecol(127,127,0);

	show_mouse(screen);

	g_gadget *rec1=new g_rectangle();
	rec1->frame=new g_happyframe_button(true);
	rec1->set_flag(GUIFLAG_CLICKABLE);

	g_gadget *rec2=new g_spacer();
	rec2->frame=new g_happyframe_button();
	rec2->set_flag(GUIFLAG_CLICKABLE);

	g_gadget *rec3=new g_spacer();
	rec3->frame=new g_happyframe_button();
	rec3->set_flag(GUIFLAG_CLICKABLE);

	g_gadget *rec4=new g_rectangle(0,180);
	rec4->frame=new g_happyframe_button();
	rec4->set_flag(GUIFLAG_CLICKABLE);

	g_gadget *rec5=new g_spacer(100,40);
	rec5->frame=new g_happyframe_button();
	rec5->set_flag(GUIFLAG_CLICKABLE);
	rec5->place=GUIPLACE_RIGHT_GOLDEN_MEAN|GUIPLACE_TOP_GOLDEN_MEAN;

	m_text *but1=new m_text("Berra");
	but1->frame=new g_happyframe_button();

	m_text *but2=new m_text("Memma");
	but2->frame=new g_happyframe_button(true);

	m_text *but3=new m_text("Kontra");
	but3->frame=new g_happyframe_button(true);

	m_text *but4=new m_text("Keso");
	but4->frame=new g_happyframe_button(true);
	but4->clear_flag(GUIFLAG_ACTIVE);

	g_gridgroup *gr1=new g_gridgroup(1,true);
	gr1->frame=new g_happyframe_group();
	gr1->set_flag(GUIFLAG_CLICKABLE);
	gr1->insert(but1,but2,but3,but4,0);

	g_group *all=new g_gridgroup(2);
	all->frame=new g_noframe();
	all->fixwidth=SCREEN_W; all->fixheight=SCREEN_H;
	all->insert(rec1,rec2,rec4,rec5,rec3,gr1,0);

	bool running=true;

	all->startup();

	while(running)
	{
		switch(all->wait_events())
		{
			case -1:
				running=false;
			break;
		}
	}

	all->shutdown();

	delete all;
}




int main(void)
{
	if(allegro_init()) die("allegro_init()");
	if(install_mouse()==-1) die("install_mouse()");
	install_timer();
	install_keyboard();

	install_fancy_sighandler();

	set_color_depth(16);
	if(set_gfx_mode(GFX_AUTODETECT,WIDTH,HEIGHT,0,0)<0) die("Screen mode not supported");

//	set_fast_screen_blender(0,0,0);
//	text_mode(-1);

//	amigafont=load_amiga_font("amigafonts/AmigaSans/13");
	amigafont=load_amiga_font("amigafonts/DigitalQuill/11");
//	amigafont=load_amiga_font("amigafonts/Mega/8");
	if(!amigafont) die("Couldn't load font");

//	DATAFILE *fontdat=load_datafile("fonts.dat");
//	for(int i=0;i<FONT_NUM;i++)
//	fonts[i]=(FONT *)fontdat[i].dat;

	stuff();

//	unload_datafile(fontdat);

	return(0);
}

END_OF_MAIN();
