#ifndef _PLAYFIELD_H_
#define _PLAYFIELD_H_

#define MAX_NAMELEN 128
#define NUM_SCORES 10
#define NUM_TYPES 3

#define PROGRESS_WIDTH 400
#define PROGRESS_HEIGHT 12

#define ONESIDED_FALSE 0
#define ONESIDED_MOEBIUS 1
#define ONESIDED_KLEIN 2

struct wireframe
{
	int a,b;
};

struct ppoint
{
	int x,y;
	int col;
};

struct highscore
{
	char name[MAX_STRLEN];
	int score,playtime,time;
};

class playfield
{
	public:
	playfield();
	~playfield();

	virtual void prepare();
	virtual void preparefield();
	virtual void unprepare();

	void allocpoints();

	virtual void recalc(vector &pos,vector &dir,vector &normal,vector &prev);
	virtual void random(vector &pos,vector &dir,vector &normal,vector &prev);

	virtual void recalc_pos(vector &pos,vector &normal,vector &prev);
	virtual void random_pos(vector &pos,vector &normal,vector &prev);

	virtual void draw();


	void firstprogress();
	void showprogress(int prog,int end);

	void loadhighscores();
	void savehighscores();

	bool ishighscore(int type,int score);
	int inserthighscore(int type,char *player,int score,int playtime,int time);
	void showhighscores(int type,int highlight);
	void mergehighscores(char *file);

	char *name,*ident;
	int onesided;

	bool prepared;

	int nlines,npoints;
	vector *point,*normal;
	wireframe *line;
	ppoint *pp;

	highscore high[NUM_TYPES][NUM_SCORES];
};

#define STAR_MAXNUM 16384
#define STAR_MAXSPEED 1.5

class starfield
{
	public:
	starfield();
	~starfield();

	void live();
	void draw();

	vector stars[STAR_MAXNUM];
};

extern starfield s;

#endif
