#include "main.h"
#include "sphere.h"
#include "swearconfig.h"

sphere::sphere():playfield() { name="Sphere"; ident="sphere"; }

void sphere::preparefield()
{
	int sphere_rings=c->detailmult[c->detaillevel]*4-1;
	int sphere_ringsegs=c->detailmult[c->detaillevel]*4;

	npoints=sphere_rings*sphere_ringsegs+2;
	nlines=sphere_rings*sphere_ringsegs+(sphere_rings+1)*sphere_ringsegs;

	allocpoints();

	int n;
	double a,sa,ca,b;

	n=0;
	for(int i=0;i<sphere_rings;i++)
	{
		a=PI*double(i+1)/(sphere_rings+1)-PI;
		sa=sin(a);
		ca=cos(a);

		for(int j=0;j<sphere_ringsegs;j++)
		{
			b=2*PI*double(j)/sphere_ringsegs;

			point[n].x=normal[n].x=sa*cos(b);
			point[n].y=normal[n].y=sa*sin(b);
			point[n].z=normal[n].z=ca;
			n++;
		}
	}

	point[n].x=normal[n].x=0;
	point[n].y=normal[n].y=0;
	point[n].z=normal[n].z=1;
	n++;

	point[n].x=normal[n].x=0;
	point[n].y=normal[n].y=0;
	point[n].z=normal[n].z=-1;
	n++;

	n=0;
	for(int i=0;i<sphere_rings;i++)
	for(int j=0;j<sphere_ringsegs;j++)
	{
		line[n].a=i*sphere_ringsegs+j;
		line[n].b=i*sphere_ringsegs+(j+1)%sphere_ringsegs;
		n++;
	}

	for(int i=0;i<sphere_rings-1;i++)
	for(int j=0;j<sphere_ringsegs;j++)
	{
		line[n].a=i*sphere_ringsegs+j;
		line[n].b=(i+1)*sphere_ringsegs+j;
		n++;
	}

	for(int j=0;j<sphere_ringsegs;j++)
	{
		line[n].a=j;
		line[n].b=npoints-1;
		n++;

		line[n].a=j+(sphere_rings-1)*sphere_ringsegs;
		line[n].b=npoints-2;
		n++;
	}
}

void sphere::recalc_pos(vector &pos,vector &normal,vector &prev)
{
	pos.normalize();
	normal=pos;
}

void sphere::random_pos(vector &pos,vector &normal,vector &prev)
{
	pos=vector::rand_sphere().normalized();
	normal=pos;
}
