#include <goa/allegro.h>
#include <goa/menu.h>

#include "main.h"
#include "swearconfig.h"



swearconfig *c;

int swearconfig::detailmult[]={4,6,8,10,12,16}; // 16,36,64,81,100,121



static config_multi cameramode_values[]=
{{CMODE_REVOLVING,"Revolving"},{CMODE_TRACKING,"Tracking"},{CMODE_SLIDING,"Sliding"}};

static config_multi smoothing_values[]=
{{INERTIA_NONE,"None"},{INERTIA_LOW,"Low"},{INERTIA_MEDIUM,"Medium"},
{INERTIA_HIGH,"High"},{INERTIA_SILLY,"Silly"}};

static config_multi trackingangle_values[]=
{{ANGLE_LOW,"Low"},{ANGLE_MEDIUM,"Medium"},{ANGLE_HIGH,"High"},{ANGLE_ABOVE,"Above"}};

static config_multi detail_values[]=
{{DETAIL_VERYLOW,"Very low"},{DETAIL_LOW,"Low"},{DETAIL_MEDIUM,"Medium"},
{DETAIL_HIGH,"High"},{DETAIL_SILLY,"Silly"}};

static config_multi vismode_values[]=
{{VISMODE_WIREFRAME,"Wireframe"},{VISMODE_DOTS,"Dots"}};

static config_multi stars_values[]=
{{STARS_NONE,"None"},{STARS_SPARSE,"Sparse"},{STARS_MEDIUM,"Medium"},
{STARS_DENSE,"Dense"},{STARS_SILLY,"Silly"}};

static config_multi starspeed_values[]=
{{STARSPEED_STATIC,"STATIC"},{STARSPEED_SLOW,"Slow"},{STARSPEED_MEDIUM,"Medium"},
{STARSPEED_FAST,"Fast"},{STARSPEED_SILLY,"Silly"}};


swearconfig::swearconfig():config("game")
{
	add(new key_entry("key_left",&key_left,KEY_LEFT,"Turn left:"));
	add(new key_entry("key_right",&key_right,KEY_RIGHT,"Turn right:"));
	add(new key_entry("key_up",&key_up,KEY_UP,"Accelerate:"));
	add(new key_entry("key_down",&key_down,KEY_DOWN,"Fast turn:"));

	add(new spacer_entry(4));

	add(new bool_entry("joystick",&joystick,false,"Joystick control:","Yes","No"));

	add(new spacer_entry(4));

	add(new bool_entry("autorestart",&autorestart,false,"Auto restart:","Yes","No"));

	add(new spacer_entry(4));

	add(new multi_entry("cameramode",&cameramode,CMODE_REVOLVING,
	3,cameramode_values,"Camera mode:"));
	add(new multi_entry("smoothing",&smoothing,INERTIA_NONE,
	5,smoothing_values,"Camera inertia:"));
	add(new multi_entry("trackingangle",&trackingangle,ANGLE_MEDIUM,
	4,trackingangle_values,"Tracking angle:"));

	add(new spacer_entry(4));

	add(new multi_entry("detaillevel",&detaillevel,DETAIL_MEDIUM,
	5,detail_values,"Detail level:"));
	add(new multi_entry("vismode",&vismode,VISMODE_WIREFRAME,
	2,vismode_values,"Look:"));
	add(new bool_entry("antialias",&antialias,false,"Antialiasing:","Yes","No"));

	add(new spacer_entry(4));

	add(new multi_entry("stars",&stars,STARS_NONE,
	5,stars_values,"Star field:"));
	add(new multi_entry("starspeed",&starspeed,STARSPEED_STATIC,
	5,starspeed_values,"Star speed:"));

	add(new spacer_entry(4));

#ifdef _OS_UNIX_
	add(new bool_entry("windowed",&windowed,true,"Run in a window","Yes","No"));
#else
	add(new bool_entry("windowed",&windowed,false,"Run in a window","Yes","No"));
#endif

	load(get_config_filename());
}

void swearconfig::run_menu()
{
	m_menu *m=new m_menu();

	make_menu(m);

	m->insert(
		new g_spacer(0,4),
		new m_text("Merge highscores",1,0),
		new g_spacer(0,4),
		new m_text("Done",-1,0),
		0
	);

	m->place=GUIPLACE_CENTER|GUIPLACE_MIDDLE;
	m->set_flag(GUIFLAG_NOMOUSE);

	switch(m->run())
	{
		case 1:
			mergescores();
		break;
	}

	bool old_windowed=windowed;
	int old_detaillevel=detaillevel,old_vismode=vismode;

	read_menu();

	delete m;

	if(detaillevel!=old_detaillevel||vismode!=old_vismode) unprepare_all();

	if(old_windowed!=windowed)
	{
		m_menu *a=new m_menu(
			new m_label("You need to quit and restart the game",&look_ni),
			new m_label("for the changes to take effect.",&look_ni),
			new g_spacer(0,8),
			new m_text("Ok",1,0),
			0
		);
		a->place=GUIPLACE_CENTER|GUIPLACE_MIDDLE;
		a->set_flag(GUIFLAG_NOMOUSE);
		a->run();

		delete a;
	}
}


/*	insert(
		new m_spacer(4),
		new m_text("Merge highscores",1,0),
		new m_spacer(4),
		new m_text("Done",-1,0),
		0
	);

	m->place=MENUPLACE_CENTER|MENUPLACE_MIDDLE;

	switch(m->run())
	{
		case 1:
			mergescores();
		break;
	}

	bool old_windowed=windowed;

	if(detaillevel!=mdet->i||vismode!=mvis->i) unprepare_all();

	if(old_windowed!=windowed)
	{
		menu *a=new menu(
			new m_label("You need to quit and restart the game",0,&look_ni),
			new m_label("for the changes to take effect.",0,&look_ni),
			new m_spacer(8),
			new m_text("Ok",1,0),
			0
		);
		a->place=MENUPLACE_CENTER|MENUPLACE_MIDDLE;
		a->run();
	}

	save();

*/
